import  pygame as p
from pygame.locals import *
import sys
from math import *
import random
import time
import numpy as np
import noise

MIN_VER = (3, 8)

if sys.version_info[:2] < MIN_VER:
    sys.exit(
        "This game requires Python {}.{}.".format(*MIN_VER)
    )

p.init()
p.font.init()

clock = p.time.Clock()
clock.tick(60)

WHITE=(255,255,255)

dark_blue = (18,61,175)
blue = (37, 93, 239)
light_blue = (83,170,244)
MAP_RES =44

sand = p.transform.scale(p.image.load("sand.png"),(MAP_RES,MAP_RES))
grass = p.transform.scale(p.image.load("grass.png"),(MAP_RES,MAP_RES))

side = [p.transform.scale(p.image.load("side1.png"),(MAP_RES,MAP_RES)),p.transform.flip(p.transform.scale(p.image.load("side1.png"),(MAP_RES,MAP_RES)),True,False),p.transform.rotate(p.transform.scale(p.image.load("side1.png"),(MAP_RES,MAP_RES)),-90),p.transform.rotate(p.transform.scale(p.image.load("side1.png"),(MAP_RES,MAP_RES)),90)]
corner = [p.transform.scale(p.image.load("corner1.png"),(MAP_RES,MAP_RES)),p.transform.flip(p.transform.scale(p.image.load("corner1.png"),(MAP_RES,MAP_RES)),False,True),p.transform.flip(p.transform.scale(p.image.load("corner1.png"),(MAP_RES,MAP_RES)),True,True),p.transform.flip(p.transform.scale(p.image.load("corner1.png"),(MAP_RES,MAP_RES)),True,False)]
opposite = [p.transform.scale(p.image.load("opposite1.png"),(MAP_RES,MAP_RES))]
sides3 = [p.transform.scale(p.image.load("3side.png"),(MAP_RES,MAP_RES))]
block= [p.transform.scale(p.image.load("onepiece1.png"),(MAP_RES,MAP_RES))]
rocher = [p.transform.scale(p.image.load("rocher1.png"),(MAP_RES,MAP_RES)),p.transform.scale(p.image.load("rocher2.png"),(MAP_RES,MAP_RES))]

compass = p.image.load("compass.png")

police = p.font.Font(None,30)

arrow = p.image.load("arrow.png")
monster =  p.transform.scale(p.image.load("meduse.png"),(44,44))
corde = p.transform.scale(p.image.load("Corde.png"),(44,32))
bois =  p.transform.scale(p.image.load("Bois.png"),(44,16))

boatupgrade = [2,8,15]
sailupgrade = [2,9]

"""Création de la fenêtre"""

icon = p.image.load('Logo.png')
p.display.set_icon(icon)

p.display.set_caption("Wind a Way")
info = p.display.Info()
size = info.current_w,info.current_h
DISPLAY = p.display.set_mode((0, 0), p.FULLSCREEN)

on = True
holdkey = []
shape = (int(info.current_w/MAP_RES+2),int(info.current_h/MAP_RES+2))
on = True
VITESSEMAX = 1
mapsize = (1980,1080)
world = np.loadtxt("map.txt")

def new() :
    global world
    
    scale = 100.0
    octaves = 4
    persistence = 0.5
    lacunarity = 2.0
    world = np.zeros(mapsize)
    saveworld = np.zeros(mapsize)
    seed = random.randint(0,500)
    print("seed was : ",seed)
    for i in range(mapsize[0]):
        for j in range(mapsize[1]):
            world[i][j] = noise.pnoise2(i/scale, 
                                        j/scale, 
                                        octaves=octaves, 
                                        persistence=persistence, 
                                        lacunarity=lacunarity, 
                                        repeatx=int(info.current_w/MAP_RES), 
                                        repeaty=int(info.current_h/MAP_RES), 
                                        base=seed)

    for i in range(mapsize[0]):
        for j in range(mapsize[1]):
            
            if world[i][j] < 0.05:
                saveworld[i][j]=0
                
            elif world[i][j] < 0.15:
                saveworld[i][j]=1
                
            elif world[i][j] < 0.25:
                saveworld[i][j]=2
                
            elif world[i][j] < 0.35:
                try:
                    waterside = 0
                    if world[i+1][j]<0.25:
                        waterside+=1
                    if world[i-1][j]<0.25:
                        waterside+=1
                    if world[i][j+1]<0.25:
                        waterside+=1
                    if world[i][j-1]<0.25:
                        waterside+=1
                        
                    if waterside == 0 :
                        saveworld[i][j]=4
                        
                    elif waterside ==1:
                        if world[i+1][j]<0.25:
                            saveworld[i][j]=5
                        if world[i-1][j]<0.25:
                            saveworld[i][j]=6
                        if world[i][j+1]<0.25:
                            saveworld[i][j]=7
                        if world[i][j-1]<0.25:
                            saveworld[i][j]=8
                            
                    elif waterside ==2:
                        if world[i+1][j]<0.25 and world[i][j-1]<0.25:
                            saveworld[i][j]=9
                        if world[i+1][j]<0.25 and world[i][j+1]<0.25:
                            saveworld[i][j]=10
                        if world[i+1][j]<0.25 and world[i-1][j]<0.25:
                            saveworld[i][j]=11
                        if world[i-1][j]<0.25 and world[i][j+1]<0.25:
                            saveworld[i][j]=12
                        if world[i][j-1]<0.25 and world[i-1][j]<0.25:
                            saveworld[i][j]=13
                        if world[i][j-1]<0.25 and world[i][j+1]<0.25:
                            saveworld[i][j]=14
                            
                    elif waterside ==3:
                        
                        if world[i+1][j]>=0.25:
                            saveworld[i][j]=15
                            
                        if world[i-1][j]>=0.25:
                            saveworld[i][j]=16
                            
                        if world[i][j+1]>=0.25:
                            saveworld[i][j]=17
                            
                        if world[i][j-1]>=0.25:
                            saveworld[i][j]=18
                            
                    elif waterside == 4 :
                        saveworld[i][j]=19
                    else :
                        saveworld[i][j]=4
                        
                except IndexError:
                    saveworld[i][j]=4
                        
            elif world[i][j] < 1:
                saveworld[i][j]=3
            
    for i in range(5000):
        x,y=random.randint(0,1919),random.randint(0,1079)
        if saveworld[x,y] ==1 :
            saveworld[x,y] = 20
        elif saveworld[x,y] ==2:
            saveworld[x,y] = 21
        elif saveworld[x,y] ==0:
            saveworld[x,y] = 22
            
    np.savetxt('map.txt', saveworld)
    world = np.loadtxt("map.txt")
    
def load():
    seeable = world[int(player1.get_pos()[0]-int(shape[0]/2)):int(player1.get_pos()[0]-int(shape[0]/2))+shape[0],int(player1.get_pos()[1]-int(shape[1]/2)):int(player1.get_pos()[1]-int(shape[1]/2))+shape[1]]
    
    decalage= (player1.get_pos()[0]-int(player1.get_pos()[0]),player1.get_pos()[1]-int(player1.get_pos()[1]))
    
    for i in range(shape[0]-1):
        for j in range(shape[1]-1):
            try :
                if seeable[i][j] == 0:
                    p.draw.rect(DISPLAY,dark_blue,((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES,MAP_RES,MAP_RES))
                    
                elif seeable[i][j] == 1:
                    p.draw.rect(DISPLAY,blue,((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES,MAP_RES,MAP_RES))
                    
                elif seeable[i][j] == 2:
                    p.draw.rect(DISPLAY,light_blue,((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES,MAP_RES,MAP_RES))
                
                elif seeable[i][j] ==3:
                    DISPLAY.blit(grass,grass.get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                    
                elif seeable[i][j]>3:
                    if seeable[i][j] ==4 :
                        DISPLAY.blit(sand,sand.get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                    elif seeable[i][j]==5:
                        DISPLAY.blit(side[0],side[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==6:
                        DISPLAY.blit(side[1],side[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==7:
                        DISPLAY.blit(side[2],side[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==8:
                        DISPLAY.blit(side[3],side[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==9:
                        DISPLAY.blit(corner[0],corner[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==10:
                        DISPLAY.blit(corner[1],corner[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==11:
                        DISPLAY.blit(opposite[0],opposite[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==12:
                        DISPLAY.blit(corner[2],corner[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==13:
                        DISPLAY.blit(corner[3],corner[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==14:
                        DISPLAY.blit(p.transform.rotate(opposite[0],90),opposite[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==15:
                        DISPLAY.blit(p.transform.rotate(sides3[0],90),sides3[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==16:
                        DISPLAY.blit(p.transform.rotate(sides3[0],-90),sides3[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==17:
                        DISPLAY.blit(sides3[0],sides3[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==18:
                        DISPLAY.blit(p.transform.flip(sides3[0],False,True),sides3[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==19:
                        DISPLAY.blit(block[0],block[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==20:
                        DISPLAY.blit(rocher[1],block[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==21:
                        DISPLAY.blit(rocher[0],block[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    elif seeable[i][j]==22:
                        p.draw.rect(DISPLAY,dark_blue,((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES,MAP_RES,MAP_RES))
                        DISPLAY.blit(monster,block[0].get_rect(topleft=((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES)))
                        
                    else :
                        p.draw.rect(DISPLAY,light_blue,((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES,MAP_RES,MAP_RES))
                else :
                    p.draw.rect(DISPLAY,light_blue,((i-decalage[0])*MAP_RES,(j-decalage[1])*MAP_RES,MAP_RES,MAP_RES))
            except :
                pass
            
class Player() :
    
    def __init__(self,pos=[100,100],nivvoile=1,nivradeau=1,inventory = {"wood":0,"rope":0}):
        self.voiles = [p.transform.scale(p.image.load("voile.png"),(256,256)),p.transform.scale(p.image.load("voile2.png"),(256,256)),p.transform.scale(p.image.load("voile3.png"),(256,256))]
        self.radeaux = [p.transform.scale(p.image.load("stage1.png"),(36,100)),p.transform.scale(p.image.load("stage2.png"),(108,100)),p.transform.scale(p.image.load("stage3.png"),(180,100)),p.transform.scale(p.image.load("stage4.png"),(180,128))]
        self.nivvoile = nivvoile
        self.nivradeau = nivradeau
        self.pos = pos
        self.inventory = inventory
        self.currentangleup=0
        self.currentangledown=0
        self.lastdamagetime= 0
        self.life = 2
    
    def get_hit(self,type):
        if self.lastdamagetime +2 < time.time():
            self.life -=1
            self.lastdamagetime = time.time()
        if self.life == 0 :
            main.die(type)
        
    def get_voile(self):
        return self.voiles[self.nivvoile-1]
    
    def get_radeau(self):
        return self.radeaux[self.nivradeau-1]
    
    def get_wood(self):
        return self.inventory["wood"]

    def get_rope(self):
        return self.inventory["rope"]
    
    def move(self,x,y=None) :
        futurepos = world[round(self.pos[0]+x)-1,round(self.pos[1]+y)-1]
        if futurepos<3:
            if y == None and (type(x) == list or type(x) == tuple):
                if self.pos[0]-shape[0]/2 + x[0]  >0:
                    self.pos[0]+= x[0]
                if self.pos[1]-shape[1]/2 + x[1] >0:
                    self.pos[1]+= x[1]
                    
            else :
                if self.pos[0]-shape[0]/2 + x >0:
                    self.pos[0]+= x
                if self.pos[1]-shape[1]/2 + y >0:
                    self.pos[1]+= y
        else :
            if futurepos>19:
                self.get_hit(futurepos)
                if y == None and (type(x) == list or type(x) == tuple):
                    if self.pos[0]-shape[0]/2 + x[0]  >0:
                        self.pos[0]+= x[0]
                    if self.pos[1]-shape[1]/2 + x[1] >0:
                        self.pos[1]+= x[1]
                        
                else :
                    if self.pos[0]-shape[0]/2 + x >0:
                        self.pos[0]+= x
                    if self.pos[1]-shape[1]/2 + y >0:
                        self.pos[1]+= y
            else :
                main.event(self.pos,futurepos)
                
    def set_angle(self,angle,type="up"):
        if type == "up" :
            self.currentangleup = angle
            if angle < 0 :
                self.currentangledown = -abs(angle+180)
            else :
                self.currentangledown = abs(angle-180)
        else :
            self.currentangledown = angle
            if angle < 0 :
                self.currentangleup = -abs(angle+180)
            else :
                self.currentangleup = abs(angle-180)

    def get_angle(self,type="up"):
        if type == "up" :
            return self.currentangleup 
        else :
            return self.currentangledown

    def get_turnspeed(self):
        return VITESSEMAX+round((VITESSEMAX)*(self.nivvoile))
    
    def get_movespeed(self):
        return 0.3+self.nivradeau*0.1

    def add_rope(self,x):
        self.inventory["rope"] += x
        
    def add_wood(self,x):
        self.inventory["wood"] += x
        
    def sub_rope(self,x):
        self.inventory["rope"] -= x
        
    def sub_wood(self,x):
        self.inventory["wood"] -= x

    def get_inventory(self):
        return self.inventory
    
    def get_pos(self):
        return self.pos

    def get_pv(self):
        return self.life
    
    def heal(self) :
        if self.life < 2:
            self.life += 1
    
class Game():
    def __init__(self,player):
        self.playing = True
        self.lore = None
        self.advencement = 0
        self.player = player
        self.dialogue = []
        file = open("intro.txt","r")
        dialogues = file.read().split("#")
        for element in dialogues :
            self.dialogue.append(element.split(";"))
        self.destination = []
        
    def start_intro(self):
        self.playing = False
        self.lore ="intro"
        
    def end_intro(self):
        global intro
        
        self.playing = True
        self.lore =None
        self.advencement +=1
        islandnotfound = True
        
        while islandnotfound == True:
            x = random.randint(50, 1870)
            y = random.randint(50, 1000)
            if world[x][y]<20 and world[x][y]>4 :
                islandnotfound = False
            else :
                islandnotfound = True
                
        self.destination = [x,y]
        intro = 0
        
    def start_talk(self,x):
        self.playing = False
        self.lore =["talk",self.advencement]
        
    def end_talk(self):
        global intro
        self.playing = True
        self.lore =None
        if self.advencement == 1:
            player1.add_wood(3)
        elif self.advencement == 1:
            player1.add_rope(2)
        elif self.advencement == 3 :
            self.win()
        self.advencement +=1
        islandnotfound = True
        
        while islandnotfound:
            x,y = random.randint(50, 1870),random.randint(50, 1000)
            if 4< world[x,y] <20 :
                islandnotfound = False
        
        self.destination = [x,y]
        intro = 0
        
    def get_playing(self) :
        return self.playing
    
    def get_state(self):
        return self.lore
    
    def event(self,pos,type):
        distance = sqrt((pos[0]-self.destination[0])**2+(pos[1]-self.destination[1])**2)
        if distance<8 :
            self.start_talk(self.advencement)
    
    def die(self,type):
        global on
        if type<22:
            texte1 = police.render("It seems you crashed on some rocks dude.",True,WHITE)
            DISPLAY.fill((0,0,0))
            DISPLAY.blit(texte1,texte1.get_rect(center=(size[0]/2,size[1]/2)))
        else:
            texte1 = police.render("It appear that these things like human meat.",True,WHITE)
            DISPLAY.fill((0,0,0))
            DISPLAY.blit(texte1,texte1.get_rect(center=(size[0]/2,size[1]/2)))
        p.display.update()
        time.sleep(2)
        on = False
        
    def win(self):
        global on
        DISPLAY.fill((0,0,0))
        DISPLAY.blit(icon,icon.get_rect(center = (size[0]/2,size[1]/2-200)))
        textes = [police.render("It seems like you won the game. GG.",True,WHITE),police.render("We hope you liked it.",True,WHITE),police.render("Made by NufNuf and ano002",True,WHITE)]
        i=0
        for texte1 in textes : 
            DISPLAY.blit(texte1,texte1.get_rect(center=(size[0]/2,size[1]/2+i*25)))
            i+=1
        p.display.update()
        time.sleep(6)
        on = False
        
player1 = Player()
main = Game(player1)
windangleup = 0
windangledown = 180

intro = 0
main.start_intro()
lastheal = 0

trash = []

while on :
    
    altf4 = 0
    for event in p.event.get() :
        if event.type == p.QUIT :
            on = False
        
        elif event.type == p.KEYDOWN :
            holdkey.append(event.key)
            
        elif event.type == p.KEYUP :
            holdkey.remove(event.key)
        
        
        elif event.type == p.MOUSEMOTION:
            xmouse,ymouse = event.pos
            
            if main.get_playing() == True :
                if ymouse < size[1]/2:
                    if xmouse < size[0]/2:
                        windangleup = 0
                        windangleup -= round(atan((size[0]/2-xmouse)/(size[1]/2-ymouse))* 180/pi)
                        windangledown = -180
                        windangledown += round(atan((size[0]/2-xmouse)/(size[1]/2-ymouse))* 180/pi)
                    else:
                        windangleup = 0
                        windangleup += round(atan((xmouse-size[0]/2)/(size[1]/2-ymouse))* 180/pi)
                        windangledown = 180
                        windangledown -= round(atan((xmouse-size[0]/2)/(size[1]/2-ymouse))* 180/pi)
                elif ymouse > size[1]/2 :
                    if xmouse < size[0]/2:
                        windangleup = -180
                        windangleup += round(atan((size[0]/2-xmouse)/(ymouse-size[1]/2))* 180/pi)
                        windangledown = 0
                        windangledown -= round(atan((size[0]/2-xmouse)/(ymouse-size[1]/2))* 180/pi)
                    else:
                        windangleup = 180
                        windangleup -= round(atan((xmouse-size[0]/2)/(ymouse-size[1]/2))* 180/pi)
                        windangledown = round(atan((xmouse-size[0]/2)/(ymouse-size[1]/2))* 180/pi)
                else : 
                    pass
        
        elif event.type == p.MOUSEBUTTONDOWN:
            
            if main.get_playing() == True :
                pass
            elif main.get_state() == "intro":
                intro+=1
            elif type(main.get_state())==list :
                intro+=1
    for key in holdkey :
        if key == 308:
            altf4 += 1
        elif key == 285:
            altf4 += 1
        
    
    if altf4 == 2 :
        on = False
        
    if main.get_playing()==True:
        
        if time.time()>player1.lastdamagetime+5 :
            player1.heal()
            lastheal = time.time()
        
        load()
        
        if len(trash) < 20 :
            if random.randint(7,15) == 15 :
                x = random.randint(int(player1.get_pos()[0]-25),int(player1.get_pos()[0]+25))
                y = random.randint(int(player1.get_pos()[1]-25),int(player1.get_pos()[1]+25))
                if random.randint(1,4) == 1 :
                    trash.append(["c",(x,y)])
                else :
                    trash.append(["w",(x,y)])
                    
        for element in trash :
            distance = sqrt((element[1][0]-player1.get_pos()[0])**2+(element[1][1]-player1.get_pos()[1])**2)
            if distance > 36 :
                trash.remove(element)
            else :
                if element[0] == "c" :
                    if corde.get_rect(center = ((element[1][0]-player1.get_pos()[0])*MAP_RES+size[0]/2,(element[1][1]-player1.get_pos()[1])*MAP_RES+size[1]/2)).colliderect(player1.get_radeau().get_rect(center= (size[0]/2,size[1]/2))) :
                        player1.add_rope(1)
                        trash.remove(element)
                    else :
                        DISPLAY.blit(corde,corde.get_rect(center = ((element[1][0]-player1.get_pos()[0])*MAP_RES+size[0]/2,(element[1][1]-player1.get_pos()[1])*MAP_RES+size[1]/2)))
                else :
                    if bois.get_rect(center = ((element[1][0]-player1.get_pos()[0])*MAP_RES+size[0]/2,(element[1][1]-player1.get_pos()[1])*MAP_RES+size[1]/2)).colliderect(player1.get_radeau().get_rect(center= (size[0]/2,size[1]/2))) :
                        player1.add_wood(1)
                        trash.remove(element)
                    DISPLAY.blit(bois,bois.get_rect(center = ((element[1][0]-player1.get_pos()[0])*MAP_RES+size[0]/2,(element[1][1]-player1.get_pos()[1])*MAP_RES+size[1]/2)))
                    
        
        if player1.nivradeau<4:
            if player1.get_wood()>=boatupgrade[player1.nivradeau-1]:
                player1.sub_wood(boatupgrade[player1.nivradeau-1])
                player1.nivradeau += 1
                
        if player1.nivvoile<3:
            if player1.get_rope()>=sailupgrade[player1.nivvoile-1]:
                player1.sub_rope(sailupgrade[player1.nivvoile-1])
                player1.nivvoile+=1
                    
        if player1.get_pos()[1] < main.destination[1]:
            if player1.get_pos()[0] < main.destination[0]:
                objctvangledown = 0
                objctvangledown -= round(atan((main.destination[0]-player1.get_pos()[0])/(main.destination[1]-player1.get_pos()[1]))* 180/pi)
                objctvangleup = -180
                objctvangleup += round(atan((main.destination[0]-player1.get_pos()[0])/(main.destination[1]-player1.get_pos()[1]))* 180/pi)
            else:
                objctvangledown = 0
                objctvangledown += round(atan((player1.get_pos()[0]-main.destination[0])/(main.destination[1]-player1.get_pos()[1]))* 180/pi)
                objctvangleup = 180
                objctvangleup -= round(atan((player1.get_pos()[0]-main.destination[0])/(main.destination[1]-player1.get_pos()[1]))* 180/pi)
        elif player1.get_pos()[1] > main.destination[1] :
            if player1.get_pos()[0] < main.destination[0]:
                objctvangledown = -180
                objctvangledown += round(atan((main.destination[0]-player1.get_pos()[0])/(player1.get_pos()[1]-main.destination[1]))* 180/pi)
                objctvangleup = 0
                objctvangleup -= round(atan((main.destination[0]-player1.get_pos()[0])/(player1.get_pos()[1]-main.destination[1]))* 180/pi)
            else:
                objctvangledown = 180
                objctvangledown -= round(atan((player1.get_pos()[0]-main.destination[0])/(player1.get_pos()[1]-main.destination[1]))* 180/pi)
                objctvangleup = round(atan((player1.get_pos()[0]-main.destination[0])/(player1.get_pos()[1]-main.destination[1]))* 180/pi)
        else : 
            pass
        
        
        DISPLAY.blit(p.transform.rotate(arrow,objctvangleup),p.transform.rotate(arrow,objctvangleup).get_rect(center=(size[0]/2,size[1]/2)))
        
        diffup = windangleup-player1.get_angle("up")
        diffdown = windangledown-player1.get_angle("down")
        
        if 180>diffup>-180:
            if diffup>=player1.get_turnspeed() : 
                voile = p.transform.rotate(player1.get_voile(), (player1.get_angle("down")-player1.get_turnspeed()))
                player1.set_angle(player1.get_angle()+player1.get_turnspeed())
            elif diffup<=-player1.get_turnspeed():
                voile = p.transform.rotate(player1.get_voile(), (player1.get_angle("down")+player1.get_turnspeed()))
                player1.set_angle(player1.get_angle()-player1.get_turnspeed())
            
            else :
                voile = p.transform.rotate(player1.get_voile(), -windangleup-180)
                player1.set_angle(windangleup)
        else :
            if  diffdown>=player1.get_turnspeed(): 
                voile = p.transform.rotate(player1.get_voile(), (player1.get_angle("down")+player1.get_turnspeed()))
                if player1.get_angle("down")<-1:
                    player1.set_angle(player1.get_angle()-player1.get_turnspeed())
                else:
                    player1.set_angle(181-player1.get_turnspeed())
                    
            elif diffdown<= -player1.get_turnspeed():
                voile = p.transform.rotate(player1.get_voile(), (player1.get_angle("down")-player1.get_turnspeed()))
                if player1.get_angle("down")>1:
                    player1.set_angle(player1.get_angle()+player1.get_turnspeed())
                else:
                    player1.set_angle(-181+player1.get_turnspeed())
            
            else :
                voile = p.transform.rotate(player1.get_voile(), -windangleup-180)
                player1.set_angle(windangleup)
            
        if -90<player1.get_angle()<90:
            movex= player1.get_movespeed()*(sin(abs(player1.get_angle())/180*pi))
            movey = player1.get_movespeed()*(cos(abs(player1.get_angle())/180*pi))
            if player1.get_angle()<0 : 
                player1.move(round(movex,5),round(movey,5))
            else :
                player1.move(round(-movex,5),round(movey,5))
        
        else :
            movex= player1.get_movespeed()*(sin(abs(player1.get_angle("down"))/180*pi))
            movey = player1.get_movespeed()*(cos(abs(player1.get_angle("down"))/180*pi))
            if player1.get_angle()<0 : 
                player1.move(round(movex,5),round(-movey,5))
            else :
                player1.move(round(-movex,5),round(-movey,5))
        
            
        DISPLAY.blit(compass,compass.get_rect(topright=(size[0]-10,10)))
        DISPLAY.blit(player1.get_radeau(),player1.get_radeau().get_rect(center=(size[0]/2,size[1]/2)))
        DISPLAY.blit(voile,voile.get_rect(center=(size[0]/2,size[1]/2)))
        s= p.Surface(size)
        s.set_alpha(abs(player1.get_pv()-2)*24)
        s.fill((255,43,43))
        DISPLAY.blit(s,(0,0))
        
    elif main.get_state() == "intro" :
        
        texte1 = police.render(main.dialogue[main.advencement][intro],True,WHITE)
        DISPLAY.fill((0,0,0))
        DISPLAY.blit(texte1,texte1.get_rect(center=(size[0]/2,size[1]/2)))
        if intro == len(main.dialogue[main.advencement])-1 :
            main.end_intro()
    
    elif type(main.get_state())==list :
        
        texte1 = police.render(main.dialogue[main.advencement][intro],True,WHITE)
        DISPLAY.fill((0,0,0))
        DISPLAY.blit(texte1,texte1.get_rect(center=(size[0]/2,size[1]/2)))
        if intro == len(main.dialogue[main.advencement])-1 :
            main.end_talk()
    
    if on:
        p.display.update()


p.quit()
